// This file is generated by TypeBuilder_h.template.

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef content_protocol_FedCm_h
#define content_protocol_FedCm_h

#include "content/common/content_export.h"
#include "content/browser/devtools/protocol/protocol.h"
// For each imported domain we generate a ValueConversions struct instead of a full domain definition
// and include Domain::API version from there.

namespace content {
namespace protocol {
namespace FedCm {
using LoginState = String;
using DialogType = String;
class Account;

// ------------- Forward and enum declarations.

namespace LoginStateEnum {
CONTENT_EXPORT extern const char SignIn[];
CONTENT_EXPORT extern const char SignUp[];
} // namespace LoginStateEnum

namespace DialogTypeEnum {
CONTENT_EXPORT extern const char AccountChooser[];
CONTENT_EXPORT extern const char AutoReauthn[];
CONTENT_EXPORT extern const char ConfirmIdpSignin[];
} // namespace DialogTypeEnum

// ------------- Type and builder declarations.

class CONTENT_EXPORT Account : public ::crdtp::ProtocolObject<Account> {
public:
    ~Account() override { }

    String GetAccountId() { return m_accountId; }
    void SetAccountId(const String& value) { m_accountId = value; }

    String GetEmail() { return m_email; }
    void SetEmail(const String& value) { m_email = value; }

    String GetName() { return m_name; }
    void SetName(const String& value) { m_name = value; }

    String GetGivenName() { return m_givenName; }
    void SetGivenName(const String& value) { m_givenName = value; }

    String GetPictureUrl() { return m_pictureUrl; }
    void SetPictureUrl(const String& value) { m_pictureUrl = value; }

    String GetIdpConfigUrl() { return m_idpConfigUrl; }
    void SetIdpConfigUrl(const String& value) { m_idpConfigUrl = value; }

    String GetIdpSigninUrl() { return m_idpSigninUrl; }
    void SetIdpSigninUrl(const String& value) { m_idpSigninUrl = value; }

    String GetLoginState() { return m_loginState; }
    void SetLoginState(const String& value) { m_loginState = value; }

    bool HasTermsOfServiceUrl() { return m_termsOfServiceUrl.has_value(); }
    String GetTermsOfServiceUrl(const String& defaultValue) const {
       return m_termsOfServiceUrl.value_or(defaultValue);
    }
    void SetTermsOfServiceUrl(const String& value) { m_termsOfServiceUrl = value; }

    bool HasPrivacyPolicyUrl() { return m_privacyPolicyUrl.has_value(); }
    String GetPrivacyPolicyUrl(const String& defaultValue) const {
       return m_privacyPolicyUrl.value_or(defaultValue);
    }
    void SetPrivacyPolicyUrl(const String& value) { m_privacyPolicyUrl = value; }

    template<int STATE>
    class AccountBuilder {
    public:
        enum {
            NoFieldsSet = 0,
            AccountIdSet = 1 << 1,
            EmailSet = 1 << 2,
            NameSet = 1 << 3,
            GivenNameSet = 1 << 4,
            PictureUrlSet = 1 << 5,
            IdpConfigUrlSet = 1 << 6,
            IdpSigninUrlSet = 1 << 7,
            LoginStateSet = 1 << 8,
            AllFieldsSet = (AccountIdSet | EmailSet | NameSet | GivenNameSet | PictureUrlSet | IdpConfigUrlSet | IdpSigninUrlSet | LoginStateSet | 0)};


        AccountBuilder<STATE | AccountIdSet>& SetAccountId(const String& value)
        {
            static_assert(!(STATE & AccountIdSet), "property accountId should not be set yet");
            m_result->SetAccountId(value);
            return castState<AccountIdSet>();
        }

        AccountBuilder<STATE | EmailSet>& SetEmail(const String& value)
        {
            static_assert(!(STATE & EmailSet), "property email should not be set yet");
            m_result->SetEmail(value);
            return castState<EmailSet>();
        }

        AccountBuilder<STATE | NameSet>& SetName(const String& value)
        {
            static_assert(!(STATE & NameSet), "property name should not be set yet");
            m_result->SetName(value);
            return castState<NameSet>();
        }

        AccountBuilder<STATE | GivenNameSet>& SetGivenName(const String& value)
        {
            static_assert(!(STATE & GivenNameSet), "property givenName should not be set yet");
            m_result->SetGivenName(value);
            return castState<GivenNameSet>();
        }

        AccountBuilder<STATE | PictureUrlSet>& SetPictureUrl(const String& value)
        {
            static_assert(!(STATE & PictureUrlSet), "property pictureUrl should not be set yet");
            m_result->SetPictureUrl(value);
            return castState<PictureUrlSet>();
        }

        AccountBuilder<STATE | IdpConfigUrlSet>& SetIdpConfigUrl(const String& value)
        {
            static_assert(!(STATE & IdpConfigUrlSet), "property idpConfigUrl should not be set yet");
            m_result->SetIdpConfigUrl(value);
            return castState<IdpConfigUrlSet>();
        }

        AccountBuilder<STATE | IdpSigninUrlSet>& SetIdpSigninUrl(const String& value)
        {
            static_assert(!(STATE & IdpSigninUrlSet), "property idpSigninUrl should not be set yet");
            m_result->SetIdpSigninUrl(value);
            return castState<IdpSigninUrlSet>();
        }

        AccountBuilder<STATE | LoginStateSet>& SetLoginState(const String& value)
        {
            static_assert(!(STATE & LoginStateSet), "property loginState should not be set yet");
            m_result->SetLoginState(value);
            return castState<LoginStateSet>();
        }

        AccountBuilder<STATE>& SetTermsOfServiceUrl(const String& value)
        {
            m_result->SetTermsOfServiceUrl(value);
            return *this;
        }

        AccountBuilder<STATE>& SetPrivacyPolicyUrl(const String& value)
        {
            m_result->SetPrivacyPolicyUrl(value);
            return *this;
        }

        std::unique_ptr<Account> Build()
        {
            static_assert(STATE == AllFieldsSet, "state should be AllFieldsSet");
            return std::move(m_result);
        }

    private:
        friend class Account;
        AccountBuilder() : m_result(new Account()) { }

        template<int STEP> AccountBuilder<STATE | STEP>& castState()
        {
            return *reinterpret_cast<AccountBuilder<STATE | STEP>*>(this);
        }

        std::unique_ptr<protocol::FedCm::Account> m_result;
    };

    static AccountBuilder<0> Create()
    {
        return AccountBuilder<0>();
    }

private:
    DECLARE_SERIALIZATION_SUPPORT();

    Account()
    {
    }

    String m_accountId;
    String m_email;
    String m_name;
    String m_givenName;
    String m_pictureUrl;
    String m_idpConfigUrl;
    String m_idpSigninUrl;
    String m_loginState;
    Maybe<String> m_termsOfServiceUrl;
    Maybe<String> m_privacyPolicyUrl;
};


// ------------- Backend interface.

class CONTENT_EXPORT Backend {
public:
    virtual ~Backend() { }

    virtual DispatchResponse Enable(Maybe<bool> in_disableRejectionDelay) = 0;
    virtual DispatchResponse Disable() = 0;
    virtual DispatchResponse SelectAccount(const String& in_dialogId, int in_accountIndex) = 0;
    virtual DispatchResponse ConfirmIdpSignin(const String& in_dialogId) = 0;
    virtual DispatchResponse DismissDialog(const String& in_dialogId, Maybe<bool> in_triggerCooldown) = 0;
    virtual DispatchResponse ResetCooldown() = 0;

};

// ------------- Frontend interface.

class CONTENT_EXPORT Frontend {
public:
  explicit Frontend(FrontendChannel* frontend_channel) : frontend_channel_(frontend_channel) {}
    void DialogShown(const String& dialogId, const String& dialogType, std::unique_ptr<protocol::Array<protocol::FedCm::Account>> accounts, const String& title, Maybe<String> subtitle = Maybe<String>());

  void flush();
  void sendRawNotification(std::unique_ptr<Serializable>);
 private:
  FrontendChannel* frontend_channel_;
};

// ------------- Dispatcher.

class CONTENT_EXPORT Dispatcher {
public:
    static void wire(UberDispatcher*, Backend*);

private:
    Dispatcher() { }
};

// ------------- Metainfo.

class CONTENT_EXPORT Metainfo {
public:
    using BackendClass = Backend;
    using FrontendClass = Frontend;
    using DispatcherClass = Dispatcher;
    static const char domainName[];
    static const char commandPrefix[];
    static const char version[];
};

} // namespace FedCm
} // namespace content
} // namespace protocol

#endif // !defined(content_protocol_FedCm_h)
