// services/network/public/mojom/isolation_info.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "services/network/public/mojom/isolation_info.mojom-shared.h"

// Used to support stream output operator for enums.
// TODO(dcheng): Consider omitting this somehow if not needed.
#include <ostream>
#include <utility>

#include "base/strings/stringprintf.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "services/network/public/mojom/isolation_info.mojom-params-data.h"
namespace network {
namespace mojom {

NOINLINE static const char* IsolationInfoRequestTypeToStringHelper(IsolationInfoRequestType value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case IsolationInfoRequestType::kMainFrame:
      return "kMainFrame";
    case IsolationInfoRequestType::kSubFrame:
      return "kSubFrame";
    case IsolationInfoRequestType::kOther:
      return "kOther";
    default:
      return nullptr;
  }
}

std::string IsolationInfoRequestTypeToString(IsolationInfoRequestType value) {
  const char *str = IsolationInfoRequestTypeToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown IsolationInfoRequestType value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, IsolationInfoRequestType value) {
  return os << IsolationInfoRequestTypeToString(value);
}

namespace internal {


// static
bool IsolationInfo_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 56, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const IsolationInfo_Data* object =
      static_cast<const IsolationInfo_Data*>(data);


  if (!::network::mojom::internal::IsolationInfoRequestType_Data
        ::Validate(object->request_type, validation_context))
    return false;

  if (!mojo::internal::ValidateStruct(object->top_frame_origin, validation_context))
    return false;

  if (!mojo::internal::ValidateStruct(object->frame_origin, validation_context))
    return false;

  if (!mojo::internal::ValidateStruct(object->nonce, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->site_for_cookies, 5, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->site_for_cookies, validation_context))
    return false;

  constexpr const mojo::internal::ContainerValidateParams& party_context_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->party_context, validation_context,
                                         &party_context_validate_params)) {
    return false;
  }

  return true;
}

IsolationInfo_Data::IsolationInfo_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace network

namespace perfetto {

// static
void TraceFormatTraits<::network::mojom::IsolationInfoRequestType>::WriteIntoTrace(
   perfetto::TracedValue context, ::network::mojom::IsolationInfoRequestType value) {
  return std::move(context).WriteString(::network::mojom::IsolationInfoRequestTypeToString(value));
}

} // namespace perfetto