// services/viz/public/mojom/compositing/filter_operation.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIZ_PUBLIC_MOJOM_COMPOSITING_FILTER_OPERATION_MOJOM_BLINK_H_
#define SERVICES_VIZ_PUBLIC_MOJOM_COMPOSITING_FILTER_OPERATION_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "services/viz/public/mojom/compositing/filter_operation.mojom-shared.h"
#include "services/viz/public/mojom/compositing/filter_operation.mojom-blink-forward.h"
#include "services/viz/public/mojom/compositing/paint_filter.mojom-blink.h"
#include "skia/public/mojom/tile_mode.mojom-blink.h"
#include "skia/public/mojom/skcolor4f.mojom-blink.h"
#include "ui/gfx/geometry/mojom/geometry.mojom-blink.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"




#include "third_party/blink/public/platform/web_common.h"




namespace WTF {
template <>
struct HashTraits<::viz::mojom::FilterType>
    : EnumHashTraits<::viz::mojom::FilterType, -1000000, -1000001> {
  static_assert(true,
                "-1000000 is a reserved enum value");
  static_assert(true,
                "-1000001 is a reserved enum value");
};
}  // namespace WTF


namespace viz::mojom::blink {








class BLINK_PLATFORM_EXPORT FilterOperation {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<FilterOperation, T>::value>;
  using DataView = FilterOperationDataView;
  using Data_ = internal::FilterOperation_Data;

  template <typename... Args>
  static FilterOperationPtr New(Args&&... args) {
    return FilterOperationPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static FilterOperationPtr From(const U& u) {
    return mojo::TypeConverter<FilterOperationPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, FilterOperation>::Convert(*this);
  }


  FilterOperation();

  FilterOperation(
      FilterType type,
      float amount,
      const ::gfx::Point& offset,
      const ::SkColor4f& drop_shadow_color,
      ::viz::mojom::blink::PaintFilterPtr image_filter,
      absl::optional<WTF::Vector<float>> matrix,
      int32_t zoom_inset,
      ::SkTileMode blur_tile_mode,
      absl::optional<WTF::Vector<::gfx::Rect>> shape);

FilterOperation(const FilterOperation&) = delete;
FilterOperation& operator=(const FilterOperation&) = delete;

  ~FilterOperation();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = FilterOperationPtr>
  FilterOperationPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, FilterOperation::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, FilterOperation::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, FilterOperation::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        FilterOperation::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        FilterOperation::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::FilterOperation_UnserializedMessageContext<
            UserType, FilterOperation::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<FilterOperation::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return FilterOperation::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::FilterOperation_UnserializedMessageContext<
            UserType, FilterOperation::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<FilterOperation::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  FilterType type;
  
  float amount;
  
  ::gfx::Point offset;
  
  ::SkColor4f drop_shadow_color;
  
  ::viz::mojom::blink::PaintFilterPtr image_filter;
  
  absl::optional<WTF::Vector<float>> matrix;
  
  int32_t zoom_inset;
  
  ::SkTileMode blur_tile_mode;
  
  absl::optional<WTF::Vector<::gfx::Rect>> shape;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, FilterOperation::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, FilterOperation::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, FilterOperation::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, FilterOperation::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
FilterOperationPtr FilterOperation::Clone() const {
  return New(
      mojo::Clone(type),
      mojo::Clone(amount),
      mojo::Clone(offset),
      mojo::Clone(drop_shadow_color),
      mojo::Clone(image_filter),
      mojo::Clone(matrix),
      mojo::Clone(zoom_inset),
      mojo::Clone(blur_tile_mode),
      mojo::Clone(shape)
  );
}

template <typename T, FilterOperation::EnableIfSame<T>*>
bool FilterOperation::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->type, other_struct.type))
    return false;
  if (!mojo::Equals(this->amount, other_struct.amount))
    return false;
  if (!mojo::Equals(this->offset, other_struct.offset))
    return false;
  if (!mojo::Equals(this->drop_shadow_color, other_struct.drop_shadow_color))
    return false;
  if (!mojo::Equals(this->image_filter, other_struct.image_filter))
    return false;
  if (!mojo::Equals(this->matrix, other_struct.matrix))
    return false;
  if (!mojo::Equals(this->zoom_inset, other_struct.zoom_inset))
    return false;
  if (!mojo::Equals(this->blur_tile_mode, other_struct.blur_tile_mode))
    return false;
  if (!mojo::Equals(this->shape, other_struct.shape))
    return false;
  return true;
}

template <typename T, FilterOperation::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.type < rhs.type)
    return true;
  if (rhs.type < lhs.type)
    return false;
  if (lhs.amount < rhs.amount)
    return true;
  if (rhs.amount < lhs.amount)
    return false;
  if (lhs.offset < rhs.offset)
    return true;
  if (rhs.offset < lhs.offset)
    return false;
  if (lhs.drop_shadow_color < rhs.drop_shadow_color)
    return true;
  if (rhs.drop_shadow_color < lhs.drop_shadow_color)
    return false;
  if (lhs.image_filter < rhs.image_filter)
    return true;
  if (rhs.image_filter < lhs.image_filter)
    return false;
  if (lhs.matrix < rhs.matrix)
    return true;
  if (rhs.matrix < lhs.matrix)
    return false;
  if (lhs.zoom_inset < rhs.zoom_inset)
    return true;
  if (rhs.zoom_inset < lhs.zoom_inset)
    return false;
  if (lhs.blur_tile_mode < rhs.blur_tile_mode)
    return true;
  if (rhs.blur_tile_mode < lhs.blur_tile_mode)
    return false;
  if (lhs.shape < rhs.shape)
    return true;
  if (rhs.shape < lhs.shape)
    return false;
  return false;
}


}  // viz::mojom::blink

namespace mojo {


template <>
struct BLINK_PLATFORM_EXPORT StructTraits<::viz::mojom::blink::FilterOperation::DataView,
                                         ::viz::mojom::blink::FilterOperationPtr> {
  static bool IsNull(const ::viz::mojom::blink::FilterOperationPtr& input) { return !input; }
  static void SetToNull(::viz::mojom::blink::FilterOperationPtr* output) { output->reset(); }

  static decltype(::viz::mojom::blink::FilterOperation::type) type(
      const ::viz::mojom::blink::FilterOperationPtr& input) {
    return input->type;
  }

  static decltype(::viz::mojom::blink::FilterOperation::amount) amount(
      const ::viz::mojom::blink::FilterOperationPtr& input) {
    return input->amount;
  }

  static const decltype(::viz::mojom::blink::FilterOperation::offset)& offset(
      const ::viz::mojom::blink::FilterOperationPtr& input) {
    return input->offset;
  }

  static const decltype(::viz::mojom::blink::FilterOperation::drop_shadow_color)& drop_shadow_color(
      const ::viz::mojom::blink::FilterOperationPtr& input) {
    return input->drop_shadow_color;
  }

  static const decltype(::viz::mojom::blink::FilterOperation::image_filter)& image_filter(
      const ::viz::mojom::blink::FilterOperationPtr& input) {
    return input->image_filter;
  }

  static const decltype(::viz::mojom::blink::FilterOperation::matrix)& matrix(
      const ::viz::mojom::blink::FilterOperationPtr& input) {
    return input->matrix;
  }

  static decltype(::viz::mojom::blink::FilterOperation::zoom_inset) zoom_inset(
      const ::viz::mojom::blink::FilterOperationPtr& input) {
    return input->zoom_inset;
  }

  static decltype(::viz::mojom::blink::FilterOperation::blur_tile_mode) blur_tile_mode(
      const ::viz::mojom::blink::FilterOperationPtr& input) {
    return input->blur_tile_mode;
  }

  static const decltype(::viz::mojom::blink::FilterOperation::shape)& shape(
      const ::viz::mojom::blink::FilterOperationPtr& input) {
    return input->shape;
  }

  static bool Read(::viz::mojom::blink::FilterOperation::DataView input, ::viz::mojom::blink::FilterOperationPtr* output);
};

}  // namespace mojo

#endif  // SERVICES_VIZ_PUBLIC_MOJOM_COMPOSITING_FILTER_OPERATION_MOJOM_BLINK_H_