// services/webnn/public/mojom/webnn_service.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_WEBNN_PUBLIC_MOJOM_WEBNN_SERVICE_MOJOM_BLINK_H_
#define SERVICES_WEBNN_PUBLIC_MOJOM_WEBNN_SERVICE_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "services/webnn/public/mojom/webnn_service.mojom-shared.h"
#include "services/webnn/public/mojom/webnn_service.mojom-blink-forward.h"
#include "services/webnn/public/mojom/webnn_graph.mojom-blink-forward.h"
#include "sandbox/policy/mojom/sandbox.mojom-blink-forward.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"






namespace WTF {
template <>
struct HashTraits<::webnn::mojom::PowerPreference>
    : EnumHashTraits<::webnn::mojom::PowerPreference, -1000000, -1000001> {
  static_assert(true,
                "-1000000 is a reserved enum value");
  static_assert(true,
                "-1000001 is a reserved enum value");
};
}  // namespace WTF


namespace WTF {
template <>
struct HashTraits<::webnn::mojom::CreateContextResult>
    : EnumHashTraits<::webnn::mojom::CreateContextResult, -1000000, -1000001> {
  static_assert(true,
                "-1000000 is a reserved enum value");
  static_assert(true,
                "-1000001 is a reserved enum value");
};
}  // namespace WTF


namespace webnn::mojom::blink {

class WebNNContextProxy;

template <typename ImplRefTraits>
class WebNNContextStub;

class WebNNContextRequestValidator;
class WebNNContextResponseValidator;


class WebNNContext
    : public WebNNContextInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = WebNNContextInterfaceBase;
  using Proxy_ = WebNNContextProxy;

  template <typename ImplRefTraits>
  using Stub_ = WebNNContextStub<ImplRefTraits>;

  using RequestValidator_ = WebNNContextRequestValidator;
  using ResponseValidator_ = WebNNContextResponseValidator;
  enum MethodMinVersions : uint32_t {
    kCreateGraphMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct CreateGraph_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~WebNNContext() = default;


  using CreateGraphCallback = base::OnceCallback<void(::mojo::PendingRemote<::webnn::mojom::blink::WebNNGraph>)>;
  
  virtual void CreateGraph(::webnn::mojom::blink::GraphInfoPtr graph_info, CreateGraphCallback callback) = 0;
};

class WebNNContextProviderProxy;

template <typename ImplRefTraits>
class WebNNContextProviderStub;

class WebNNContextProviderRequestValidator;
class WebNNContextProviderResponseValidator;


class WebNNContextProvider
    : public WebNNContextProviderInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = WebNNContextProviderInterfaceBase;
  using Proxy_ = WebNNContextProviderProxy;

  template <typename ImplRefTraits>
  using Stub_ = WebNNContextProviderStub<ImplRefTraits>;

  using RequestValidator_ = WebNNContextProviderRequestValidator;
  using ResponseValidator_ = WebNNContextProviderResponseValidator;
  enum MethodMinVersions : uint32_t {
    kCreateWebNNContextMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct CreateWebNNContext_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~WebNNContextProvider() = default;


  using CreateWebNNContextCallback = base::OnceCallback<void(CreateContextResult, ::mojo::PendingRemote<WebNNContext>)>;
  
  virtual void CreateWebNNContext(CreateContextOptionsPtr options, CreateWebNNContextCallback callback) = 0;
};

class WebNNServiceProxy;

template <typename ImplRefTraits>
class WebNNServiceStub;

class WebNNServiceRequestValidator;


class WebNNService
    : public WebNNServiceInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr auto kServiceSandbox = sandbox::mojom::Sandbox::kGpu;
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = WebNNServiceInterfaceBase;
  using Proxy_ = WebNNServiceProxy;

  template <typename ImplRefTraits>
  using Stub_ = WebNNServiceStub<ImplRefTraits>;

  using RequestValidator_ = WebNNServiceRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kBindWebNNContextProviderMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct BindWebNNContextProvider_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~WebNNService() = default;

  
  virtual void BindWebNNContextProvider(::mojo::PendingReceiver<WebNNContextProvider> receiver) = 0;
};



class  WebNNContextProxy
    : public WebNNContext {
 public:
  using InterfaceType = WebNNContext;

  explicit WebNNContextProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void CreateGraph(::webnn::mojom::blink::GraphInfoPtr graph_info, CreateGraphCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class  WebNNContextProviderProxy
    : public WebNNContextProvider {
 public:
  using InterfaceType = WebNNContextProvider;

  explicit WebNNContextProviderProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void CreateWebNNContext(CreateContextOptionsPtr options, CreateWebNNContextCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class  WebNNServiceProxy
    : public WebNNService {
 public:
  using InterfaceType = WebNNService;

  explicit WebNNServiceProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void BindWebNNContextProvider(::mojo::PendingReceiver<WebNNContextProvider> receiver) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  WebNNContextStubDispatch {
 public:
  static bool Accept(WebNNContext* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      WebNNContext* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<WebNNContext>>
class WebNNContextStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  WebNNContextStub() = default;
  ~WebNNContextStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WebNNContextStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WebNNContextStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  WebNNContextProviderStubDispatch {
 public:
  static bool Accept(WebNNContextProvider* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      WebNNContextProvider* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<WebNNContextProvider>>
class WebNNContextProviderStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  WebNNContextProviderStub() = default;
  ~WebNNContextProviderStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WebNNContextProviderStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WebNNContextProviderStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  WebNNServiceStubDispatch {
 public:
  static bool Accept(WebNNService* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      WebNNService* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<WebNNService>>
class WebNNServiceStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  WebNNServiceStub() = default;
  ~WebNNServiceStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WebNNServiceStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WebNNServiceStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  WebNNContextRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  WebNNContextProviderRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  WebNNServiceRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  WebNNContextResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  WebNNContextProviderResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





class  CreateContextOptions {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<CreateContextOptions, T>::value>;
  using DataView = CreateContextOptionsDataView;
  using Data_ = internal::CreateContextOptions_Data;

  template <typename... Args>
  static CreateContextOptionsPtr New(Args&&... args) {
    return CreateContextOptionsPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static CreateContextOptionsPtr From(const U& u) {
    return mojo::TypeConverter<CreateContextOptionsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, CreateContextOptions>::Convert(*this);
  }


  CreateContextOptions();

  explicit CreateContextOptions(
      PowerPreference power_preference);


  ~CreateContextOptions();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = CreateContextOptionsPtr>
  CreateContextOptionsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, CreateContextOptions::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, CreateContextOptions::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, CreateContextOptions::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        CreateContextOptions::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        CreateContextOptions::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::CreateContextOptions_UnserializedMessageContext<
            UserType, CreateContextOptions::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<CreateContextOptions::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return CreateContextOptions::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::CreateContextOptions_UnserializedMessageContext<
            UserType, CreateContextOptions::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<CreateContextOptions::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  PowerPreference power_preference;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, CreateContextOptions::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, CreateContextOptions::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, CreateContextOptions::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, CreateContextOptions::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}




template <typename StructPtrType>
CreateContextOptionsPtr CreateContextOptions::Clone() const {
  return New(
      mojo::Clone(power_preference)
  );
}

template <typename T, CreateContextOptions::EnableIfSame<T>*>
bool CreateContextOptions::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->power_preference, other_struct.power_preference))
    return false;
  return true;
}

template <typename T, CreateContextOptions::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.power_preference < rhs.power_preference)
    return true;
  if (rhs.power_preference < lhs.power_preference)
    return false;
  return false;
}


}  // webnn::mojom::blink

namespace mojo {


template <>
struct  StructTraits<::webnn::mojom::blink::CreateContextOptions::DataView,
                                         ::webnn::mojom::blink::CreateContextOptionsPtr> {
  static bool IsNull(const ::webnn::mojom::blink::CreateContextOptionsPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::CreateContextOptionsPtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::CreateContextOptions::power_preference) power_preference(
      const ::webnn::mojom::blink::CreateContextOptionsPtr& input) {
    return input->power_preference;
  }

  static bool Read(::webnn::mojom::blink::CreateContextOptions::DataView input, ::webnn::mojom::blink::CreateContextOptionsPtr* output);
};

}  // namespace mojo

#endif  // SERVICES_WEBNN_PUBLIC_MOJOM_WEBNN_SERVICE_MOJOM_BLINK_H_