// services/webnn/public/mojom/webnn_service.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "services/webnn/public/mojom/webnn_service.mojom-shared.h"

// Used to support stream output operator for enums.
// TODO(dcheng): Consider omitting this somehow if not needed.
#include <ostream>
#include <utility>

#include "base/strings/stringprintf.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "services/webnn/public/mojom/webnn_service.mojom-params-data.h"
namespace webnn {
namespace mojom {

NOINLINE static const char* PowerPreferenceToStringHelper(PowerPreference value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case PowerPreference::kDefault:
      return "kDefault";
    case PowerPreference::kHighPerformance:
      return "kHighPerformance";
    case PowerPreference::kLowPower:
      return "kLowPower";
    default:
      return nullptr;
  }
}

std::string PowerPreferenceToString(PowerPreference value) {
  const char *str = PowerPreferenceToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown PowerPreference value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, PowerPreference value) {
  return os << PowerPreferenceToString(value);
}

NOINLINE static const char* CreateContextResultToStringHelper(CreateContextResult value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case CreateContextResult::kOk:
      return "kOk";
    case CreateContextResult::kUnknownError:
      return "kUnknownError";
    case CreateContextResult::kNotSupported:
      return "kNotSupported";
    default:
      return nullptr;
  }
}

std::string CreateContextResultToString(CreateContextResult value) {
  const char *str = CreateContextResultToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown CreateContextResult value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, CreateContextResult value) {
  return os << CreateContextResultToString(value);
}

namespace internal {


// static
bool CreateContextOptions_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const CreateContextOptions_Data* object =
      static_cast<const CreateContextOptions_Data*>(data);


  if (!::webnn::mojom::internal::PowerPreference_Data
        ::Validate(object->power_preference, validation_context))
    return false;

  return true;
}

CreateContextOptions_Data::CreateContextOptions_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool WebNNContext_CreateGraph_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const WebNNContext_CreateGraph_Params_Data* object =
      static_cast<const WebNNContext_CreateGraph_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->graph_info, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->graph_info, validation_context))
    return false;

  return true;
}

WebNNContext_CreateGraph_Params_Data::WebNNContext_CreateGraph_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool WebNNContext_CreateGraph_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const WebNNContext_CreateGraph_ResponseParams_Data* object =
      static_cast<const WebNNContext_CreateGraph_ResponseParams_Data*>(data);

  if (!mojo::internal::ValidateHandleOrInterface(object->remote,
                                                 validation_context)) {
    return false;
  }

  return true;
}

WebNNContext_CreateGraph_ResponseParams_Data::WebNNContext_CreateGraph_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool WebNNContextProvider_CreateWebNNContext_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const WebNNContextProvider_CreateWebNNContext_Params_Data* object =
      static_cast<const WebNNContextProvider_CreateWebNNContext_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->options, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->options, validation_context))
    return false;

  return true;
}

WebNNContextProvider_CreateWebNNContext_Params_Data::WebNNContextProvider_CreateWebNNContext_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool WebNNContextProvider_CreateWebNNContext_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const WebNNContextProvider_CreateWebNNContext_ResponseParams_Data* object =
      static_cast<const WebNNContextProvider_CreateWebNNContext_ResponseParams_Data*>(data);


  if (!::webnn::mojom::internal::CreateContextResult_Data
        ::Validate(object->result, validation_context))
    return false;

  if (!mojo::internal::ValidateHandleOrInterface(object->remote,
                                                 validation_context)) {
    return false;
  }

  return true;
}

WebNNContextProvider_CreateWebNNContext_ResponseParams_Data::WebNNContextProvider_CreateWebNNContext_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool WebNNService_BindWebNNContextProvider_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const WebNNService_BindWebNNContextProvider_Params_Data* object =
      static_cast<const WebNNService_BindWebNNContextProvider_Params_Data*>(data);

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->receiver, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->receiver,
                                                 validation_context)) {
    return false;
  }

  return true;
}

WebNNService_BindWebNNContextProvider_Params_Data::WebNNService_BindWebNNContextProvider_Params_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace webnn

namespace perfetto {

// static
void TraceFormatTraits<::webnn::mojom::PowerPreference>::WriteIntoTrace(
   perfetto::TracedValue context, ::webnn::mojom::PowerPreference value) {
  return std::move(context).WriteString(::webnn::mojom::PowerPreferenceToString(value));
}

} // namespace perfetto

namespace perfetto {

// static
void TraceFormatTraits<::webnn::mojom::CreateContextResult>::WriteIntoTrace(
   perfetto::TracedValue context, ::webnn::mojom::CreateContextResult value) {
  return std::move(context).WriteString(::webnn::mojom::CreateContextResultToString(value));
}

} // namespace perfetto