// third_party/blink/public/mojom/gpu/gpu.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_GPU_GPU_MOJOM_BLINK_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_GPU_GPU_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/gpu/gpu.mojom-shared.h"
#include "third_party/blink/public/mojom/gpu/gpu.mojom-blink-forward.h"
#include "url/mojom/url.mojom-blink.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/renderer/platform/platform_export.h"




namespace blink::mojom::blink {

class GpuDataManagerProxy;

template <typename ImplRefTraits>
class GpuDataManagerStub;

class GpuDataManagerRequestValidator;
class GpuDataManagerResponseValidator;


class PLATFORM_EXPORT GpuDataManager
    : public GpuDataManagerInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static inline constexpr uint32_t kSyncMethodOrdinals[] = {
    1445716740
  };
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = GpuDataManagerInterfaceBase;
  using Proxy_ = GpuDataManagerProxy;

  template <typename ImplRefTraits>
  using Stub_ = GpuDataManagerStub<ImplRefTraits>;

  using RequestValidator_ = GpuDataManagerRequestValidator;
  using ResponseValidator_ = GpuDataManagerResponseValidator;
  enum MethodMinVersions : uint32_t {
    kAre3DAPIsBlockedForUrlMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct Are3DAPIsBlockedForUrl_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~GpuDataManager() = default;

  // Sync method. This signature is used by the client side; the service side
  // should implement the signature with callback below.
  
  virtual bool Are3DAPIsBlockedForUrl(const ::blink::KURL& url, bool* out_blocked);

  using Are3DAPIsBlockedForUrlCallback = base::OnceCallback<void(bool)>;
  
  virtual void Are3DAPIsBlockedForUrl(const ::blink::KURL& url, Are3DAPIsBlockedForUrlCallback callback) = 0;
};



class PLATFORM_EXPORT GpuDataManagerProxy
    : public GpuDataManager {
 public:
  using InterfaceType = GpuDataManager;

  explicit GpuDataManagerProxy(mojo::MessageReceiverWithResponder* receiver);
  
  bool Are3DAPIsBlockedForUrl(const ::blink::KURL& url, bool* out_blocked) final;
  
  void Are3DAPIsBlockedForUrl(const ::blink::KURL& url, Are3DAPIsBlockedForUrlCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class PLATFORM_EXPORT GpuDataManagerStubDispatch {
 public:
  static bool Accept(GpuDataManager* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      GpuDataManager* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<GpuDataManager>>
class GpuDataManagerStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  GpuDataManagerStub() = default;
  ~GpuDataManagerStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return GpuDataManagerStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return GpuDataManagerStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class PLATFORM_EXPORT GpuDataManagerRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class PLATFORM_EXPORT GpuDataManagerResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // blink::mojom::blink

namespace mojo {

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_GPU_GPU_MOJOM_BLINK_H_