// third_party/blink/public/mojom/mediastream/media_stream.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_MEDIASTREAM_MEDIA_STREAM_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_MEDIASTREAM_MEDIA_STREAM_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/mediastream/media_stream.mojom-shared.h"
#include "third_party/blink/public/mojom/mediastream/media_stream.mojom-forward.h"
#include "media/capture/mojom/video_capture_types.mojom.h"
#include "media/mojo/mojom/audio_parameters.mojom.h"
#include "media/mojo/mojom/display_media_information.mojom.h"
#include "mojo/public/mojom/base/token.mojom.h"
#include "mojo/public/mojom/base/unguessable_token.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "mojo/public/cpp/bindings/lib/native_enum_serialization.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"
#include "third_party/blink/public/common/mediastream/media_stream_mojom_traits.h"
#include "third_party/blink/public/common/common_export.h"




namespace blink::mojom {

class MediaStreamDeviceObserverProxy;

template <typename ImplRefTraits>
class MediaStreamDeviceObserverStub;

class MediaStreamDeviceObserverRequestValidator;


class BLINK_COMMON_EXPORT MediaStreamDeviceObserver
    : public MediaStreamDeviceObserverInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = MediaStreamDeviceObserverInterfaceBase;
  using Proxy_ = MediaStreamDeviceObserverProxy;

  template <typename ImplRefTraits>
  using Stub_ = MediaStreamDeviceObserverStub<ImplRefTraits>;

  using RequestValidator_ = MediaStreamDeviceObserverRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kOnDeviceStoppedMinVersion = 0,
    kOnDeviceChangedMinVersion = 0,
    kOnDeviceRequestStateChangeMinVersion = 0,
    kOnDeviceCaptureConfigurationChangeMinVersion = 0,
    kOnDeviceCaptureHandleChangeMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct OnDeviceStopped_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct OnDeviceChanged_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct OnDeviceRequestStateChange_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct OnDeviceCaptureConfigurationChange_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct OnDeviceCaptureHandleChange_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~MediaStreamDeviceObserver() = default;

  
  virtual void OnDeviceStopped(const std::string& label, const ::blink::MediaStreamDevice& device) = 0;

  
  virtual void OnDeviceChanged(const std::string& label, const ::blink::MediaStreamDevice& old_device, const ::blink::MediaStreamDevice& new_device) = 0;

  
  virtual void OnDeviceRequestStateChange(const std::string& label, const ::blink::MediaStreamDevice& device, MediaStreamStateChange new_state) = 0;

  
  virtual void OnDeviceCaptureConfigurationChange(const std::string& label, const ::blink::MediaStreamDevice& device) = 0;

  
  virtual void OnDeviceCaptureHandleChange(const std::string& label, const ::blink::MediaStreamDevice& device) = 0;
};

class MediaStreamDispatcherHostProxy;

template <typename ImplRefTraits>
class MediaStreamDispatcherHostStub;

class MediaStreamDispatcherHostRequestValidator;
class MediaStreamDispatcherHostResponseValidator;


class BLINK_COMMON_EXPORT MediaStreamDispatcherHost
    : public MediaStreamDispatcherHostInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static inline constexpr uint32_t kSyncMethodOrdinals[] = {
    9
  };
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = MediaStreamDispatcherHostInterfaceBase;
  using Proxy_ = MediaStreamDispatcherHostProxy;

  template <typename ImplRefTraits>
  using Stub_ = MediaStreamDispatcherHostStub<ImplRefTraits>;

  using RequestValidator_ = MediaStreamDispatcherHostRequestValidator;
  using ResponseValidator_ = MediaStreamDispatcherHostResponseValidator;
  enum MethodMinVersions : uint32_t {
    kGenerateStreamsMinVersion = 0,
    kFocusCapturedSurfaceMinVersion = 0,
    kCancelRequestMinVersion = 0,
    kStopStreamDeviceMinVersion = 0,
    kOpenDeviceMinVersion = 0,
    kCloseDeviceMinVersion = 0,
    kSetCapturingLinkSecuredMinVersion = 0,
    kOnStreamStartedMinVersion = 0,
    kCropMinVersion = 0,
    kGetOpenDeviceMinVersion = 0,
    kKeepDeviceAliveForTransferMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct GenerateStreams_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct FocusCapturedSurface_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct CancelRequest_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct StopStreamDevice_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct OpenDevice_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct CloseDevice_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct SetCapturingLinkSecured_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct OnStreamStarted_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct Crop_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct GetOpenDevice_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct KeepDeviceAliveForTransfer_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~MediaStreamDispatcherHost() = default;


  using GenerateStreamsCallback = base::OnceCallback<void(MediaStreamRequestResult, const std::string&, StreamDevicesSetPtr, bool)>;
  
  virtual void GenerateStreams(int32_t request_id, const ::blink::StreamControls& controls, bool user_gesture, StreamSelectionInfoPtr audio_stream_selection_info, GenerateStreamsCallback callback) = 0;

  
  virtual void FocusCapturedSurface(const std::string& label, bool focus) = 0;

  
  virtual void CancelRequest(int32_t request_id) = 0;

  
  virtual void StopStreamDevice(const std::string& device_id, const absl::optional<::base::UnguessableToken>& session_id) = 0;


  using OpenDeviceCallback = base::OnceCallback<void(bool, const std::string&, const ::blink::MediaStreamDevice&)>;
  
  virtual void OpenDevice(int32_t request_id, const std::string& device_id, MediaStreamType type, OpenDeviceCallback callback) = 0;

  
  virtual void CloseDevice(const std::string& label) = 0;

  
  virtual void SetCapturingLinkSecured(const absl::optional<::base::UnguessableToken>& session_id, MediaStreamType type, bool is_secure) = 0;

  
  virtual void OnStreamStarted(const std::string& label) = 0;


  using CropCallback = base::OnceCallback<void(::media::mojom::CropRequestResult)>;
  
  virtual void Crop(const ::base::UnguessableToken& device_id, const ::base::Token& crop_id, uint32_t crop_version, CropCallback callback) = 0;

  // Sync method. This signature is used by the client side; the service side
  // should implement the signature with callback below.
  
  virtual bool GetOpenDevice(int32_t request_id, const ::base::UnguessableToken& session_id, const ::base::UnguessableToken& transfer_id, MediaStreamRequestResult* out_result, GetOpenDeviceResponsePtr* out_response);

  using GetOpenDeviceCallback = base::OnceCallback<void(MediaStreamRequestResult, GetOpenDeviceResponsePtr)>;
  
  virtual void GetOpenDevice(int32_t request_id, const ::base::UnguessableToken& session_id, const ::base::UnguessableToken& transfer_id, GetOpenDeviceCallback callback) = 0;


  using KeepDeviceAliveForTransferCallback = base::OnceCallback<void(bool)>;
  
  virtual void KeepDeviceAliveForTransfer(const ::base::UnguessableToken& session_id, const ::base::UnguessableToken& transfer_id, KeepDeviceAliveForTransferCallback callback) = 0;
};

class MediaStreamTrackMetricsHostProxy;

template <typename ImplRefTraits>
class MediaStreamTrackMetricsHostStub;

class MediaStreamTrackMetricsHostRequestValidator;


class BLINK_COMMON_EXPORT MediaStreamTrackMetricsHost
    : public MediaStreamTrackMetricsHostInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = MediaStreamTrackMetricsHostInterfaceBase;
  using Proxy_ = MediaStreamTrackMetricsHostProxy;

  template <typename ImplRefTraits>
  using Stub_ = MediaStreamTrackMetricsHostStub<ImplRefTraits>;

  using RequestValidator_ = MediaStreamTrackMetricsHostRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kAddTrackMinVersion = 0,
    kRemoveTrackMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct AddTrack_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct RemoveTrack_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~MediaStreamTrackMetricsHost() = default;

  
  virtual void AddTrack(uint64_t id, bool is_audio, bool is_remote) = 0;

  
  virtual void RemoveTrack(uint64_t id) = 0;
};



class BLINK_COMMON_EXPORT MediaStreamDeviceObserverProxy
    : public MediaStreamDeviceObserver {
 public:
  using InterfaceType = MediaStreamDeviceObserver;

  explicit MediaStreamDeviceObserverProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void OnDeviceStopped(const std::string& label, const ::blink::MediaStreamDevice& device) final;
  
  void OnDeviceChanged(const std::string& label, const ::blink::MediaStreamDevice& old_device, const ::blink::MediaStreamDevice& new_device) final;
  
  void OnDeviceRequestStateChange(const std::string& label, const ::blink::MediaStreamDevice& device, MediaStreamStateChange new_state) final;
  
  void OnDeviceCaptureConfigurationChange(const std::string& label, const ::blink::MediaStreamDevice& device) final;
  
  void OnDeviceCaptureHandleChange(const std::string& label, const ::blink::MediaStreamDevice& device) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class BLINK_COMMON_EXPORT MediaStreamDispatcherHostProxy
    : public MediaStreamDispatcherHost {
 public:
  using InterfaceType = MediaStreamDispatcherHost;

  explicit MediaStreamDispatcherHostProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void GenerateStreams(int32_t request_id, const ::blink::StreamControls& controls, bool user_gesture, StreamSelectionInfoPtr audio_stream_selection_info, GenerateStreamsCallback callback) final;
  
  void FocusCapturedSurface(const std::string& label, bool focus) final;
  
  void CancelRequest(int32_t request_id) final;
  
  void StopStreamDevice(const std::string& device_id, const absl::optional<::base::UnguessableToken>& session_id) final;
  
  void OpenDevice(int32_t request_id, const std::string& device_id, MediaStreamType type, OpenDeviceCallback callback) final;
  
  void CloseDevice(const std::string& label) final;
  
  void SetCapturingLinkSecured(const absl::optional<::base::UnguessableToken>& session_id, MediaStreamType type, bool is_secure) final;
  
  void OnStreamStarted(const std::string& label) final;
  
  void Crop(const ::base::UnguessableToken& device_id, const ::base::Token& crop_id, uint32_t crop_version, CropCallback callback) final;
  
  bool GetOpenDevice(int32_t request_id, const ::base::UnguessableToken& session_id, const ::base::UnguessableToken& transfer_id, MediaStreamRequestResult* out_result, GetOpenDeviceResponsePtr* out_response) final;
  
  void GetOpenDevice(int32_t request_id, const ::base::UnguessableToken& session_id, const ::base::UnguessableToken& transfer_id, GetOpenDeviceCallback callback) final;
  
  void KeepDeviceAliveForTransfer(const ::base::UnguessableToken& session_id, const ::base::UnguessableToken& transfer_id, KeepDeviceAliveForTransferCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class BLINK_COMMON_EXPORT MediaStreamTrackMetricsHostProxy
    : public MediaStreamTrackMetricsHost {
 public:
  using InterfaceType = MediaStreamTrackMetricsHost;

  explicit MediaStreamTrackMetricsHostProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void AddTrack(uint64_t id, bool is_audio, bool is_remote) final;
  
  void RemoveTrack(uint64_t id) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT MediaStreamDeviceObserverStubDispatch {
 public:
  static bool Accept(MediaStreamDeviceObserver* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      MediaStreamDeviceObserver* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<MediaStreamDeviceObserver>>
class MediaStreamDeviceObserverStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  MediaStreamDeviceObserverStub() = default;
  ~MediaStreamDeviceObserverStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return MediaStreamDeviceObserverStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return MediaStreamDeviceObserverStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT MediaStreamDispatcherHostStubDispatch {
 public:
  static bool Accept(MediaStreamDispatcherHost* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      MediaStreamDispatcherHost* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<MediaStreamDispatcherHost>>
class MediaStreamDispatcherHostStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  MediaStreamDispatcherHostStub() = default;
  ~MediaStreamDispatcherHostStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return MediaStreamDispatcherHostStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return MediaStreamDispatcherHostStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT MediaStreamTrackMetricsHostStubDispatch {
 public:
  static bool Accept(MediaStreamTrackMetricsHost* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      MediaStreamTrackMetricsHost* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<MediaStreamTrackMetricsHost>>
class MediaStreamTrackMetricsHostStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  MediaStreamTrackMetricsHostStub() = default;
  ~MediaStreamTrackMetricsHostStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return MediaStreamTrackMetricsHostStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return MediaStreamTrackMetricsHostStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT MediaStreamDeviceObserverRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT MediaStreamDispatcherHostRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT MediaStreamTrackMetricsHostRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT MediaStreamDispatcherHostResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};







class BLINK_COMMON_EXPORT TrackControls {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<TrackControls, T>::value>;
  using DataView = TrackControlsDataView;
  using Data_ = internal::TrackControls_Data;

  template <typename... Args>
  static TrackControlsPtr New(Args&&... args) {
    return TrackControlsPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static TrackControlsPtr From(const U& u) {
    return mojo::TypeConverter<TrackControlsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, TrackControls>::Convert(*this);
  }


  TrackControls();

  TrackControls(
      MediaStreamType stream_type,
      const std::string& device_id);


  ~TrackControls();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = TrackControlsPtr>
  TrackControlsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, TrackControls::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, TrackControls::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, TrackControls::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        TrackControls::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        TrackControls::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::TrackControls_UnserializedMessageContext<
            UserType, TrackControls::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<TrackControls::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return TrackControls::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::TrackControls_UnserializedMessageContext<
            UserType, TrackControls::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<TrackControls::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  MediaStreamType stream_type;
  
  std::string device_id;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, TrackControls::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, TrackControls::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, TrackControls::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, TrackControls::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}











class BLINK_COMMON_EXPORT StreamSelectionInfo {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<StreamSelectionInfo, T>::value>;
  using DataView = StreamSelectionInfoDataView;
  using Data_ = internal::StreamSelectionInfo_Data;

  template <typename... Args>
  static StreamSelectionInfoPtr New(Args&&... args) {
    return StreamSelectionInfoPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static StreamSelectionInfoPtr From(const U& u) {
    return mojo::TypeConverter<StreamSelectionInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, StreamSelectionInfo>::Convert(*this);
  }


  StreamSelectionInfo();

  StreamSelectionInfo(
      StreamSelectionStrategy strategy,
      const absl::optional<::base::UnguessableToken>& session_id);


  ~StreamSelectionInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = StreamSelectionInfoPtr>
  StreamSelectionInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, StreamSelectionInfo::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, StreamSelectionInfo::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, StreamSelectionInfo::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        StreamSelectionInfo::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        StreamSelectionInfo::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::StreamSelectionInfo_UnserializedMessageContext<
            UserType, StreamSelectionInfo::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<StreamSelectionInfo::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return StreamSelectionInfo::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::StreamSelectionInfo_UnserializedMessageContext<
            UserType, StreamSelectionInfo::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<StreamSelectionInfo::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  StreamSelectionStrategy strategy;
  
  absl::optional<::base::UnguessableToken> session_id;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, StreamSelectionInfo::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, StreamSelectionInfo::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, StreamSelectionInfo::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, StreamSelectionInfo::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class BLINK_COMMON_EXPORT MediaStreamDevice {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<MediaStreamDevice, T>::value>;
  using DataView = MediaStreamDeviceDataView;
  using Data_ = internal::MediaStreamDevice_Data;

  template <typename... Args>
  static MediaStreamDevicePtr New(Args&&... args) {
    return MediaStreamDevicePtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static MediaStreamDevicePtr From(const U& u) {
    return mojo::TypeConverter<MediaStreamDevicePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, MediaStreamDevice>::Convert(*this);
  }


  MediaStreamDevice();

  MediaStreamDevice(
      MediaStreamType type,
      const std::string& id,
      int64_t display_id,
      ::media::VideoFacingMode video_facing,
      const absl::optional<std::string>& group_id,
      const absl::optional<std::string>& matched_output_device_id,
      const std::string& name,
      const ::media::AudioParameters& input,
      const absl::optional<::base::UnguessableToken>& session_id,
      ::media::mojom::DisplayMediaInformationPtr display_media_info);

MediaStreamDevice(const MediaStreamDevice&) = delete;
MediaStreamDevice& operator=(const MediaStreamDevice&) = delete;

  ~MediaStreamDevice();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = MediaStreamDevicePtr>
  MediaStreamDevicePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, MediaStreamDevice::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, MediaStreamDevice::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, MediaStreamDevice::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        MediaStreamDevice::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        MediaStreamDevice::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::MediaStreamDevice_UnserializedMessageContext<
            UserType, MediaStreamDevice::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<MediaStreamDevice::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return MediaStreamDevice::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::MediaStreamDevice_UnserializedMessageContext<
            UserType, MediaStreamDevice::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<MediaStreamDevice::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  MediaStreamType type;
  
  std::string id;
  
  int64_t display_id;
  
  ::media::VideoFacingMode video_facing;
  
  absl::optional<std::string> group_id;
  
  absl::optional<std::string> matched_output_device_id;
  
  std::string name;
  
  ::media::AudioParameters input;
  
  absl::optional<::base::UnguessableToken> session_id;
  
  ::media::mojom::DisplayMediaInformationPtr display_media_info;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, MediaStreamDevice::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, MediaStreamDevice::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, MediaStreamDevice::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, MediaStreamDevice::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class BLINK_COMMON_EXPORT StreamControls {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<StreamControls, T>::value>;
  using DataView = StreamControlsDataView;
  using Data_ = internal::StreamControls_Data;

  template <typename... Args>
  static StreamControlsPtr New(Args&&... args) {
    return StreamControlsPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static StreamControlsPtr From(const U& u) {
    return mojo::TypeConverter<StreamControlsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, StreamControls>::Convert(*this);
  }


  StreamControls();

  StreamControls(
      const ::blink::TrackControls& audio,
      const ::blink::TrackControls& video,
      bool hotword_enabled,
      bool disable_local_echo,
      bool suppress_local_audio_playback,
      bool exclude_system_audio,
      bool exclude_self_browser_surface,
      bool request_pan_tilt_zoom_permission,
      bool request_all_screens,
      PreferredDisplaySurface preferred_display_surface,
      bool dynamic_surface_switching_requested);


  ~StreamControls();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = StreamControlsPtr>
  StreamControlsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, StreamControls::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, StreamControls::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, StreamControls::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        StreamControls::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        StreamControls::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::StreamControls_UnserializedMessageContext<
            UserType, StreamControls::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<StreamControls::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return StreamControls::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::StreamControls_UnserializedMessageContext<
            UserType, StreamControls::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<StreamControls::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::blink::TrackControls audio;
  
  ::blink::TrackControls video;
  
  bool hotword_enabled;
  
  bool disable_local_echo;
  
  bool suppress_local_audio_playback;
  
  bool exclude_system_audio;
  
  bool exclude_self_browser_surface;
  
  bool request_pan_tilt_zoom_permission;
  
  bool request_all_screens;
  
  PreferredDisplaySurface preferred_display_surface;
  
  bool dynamic_surface_switching_requested;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, StreamControls::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, StreamControls::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, StreamControls::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, StreamControls::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class BLINK_COMMON_EXPORT GetOpenDeviceResponse {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<GetOpenDeviceResponse, T>::value>;
  using DataView = GetOpenDeviceResponseDataView;
  using Data_ = internal::GetOpenDeviceResponse_Data;

  template <typename... Args>
  static GetOpenDeviceResponsePtr New(Args&&... args) {
    return GetOpenDeviceResponsePtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static GetOpenDeviceResponsePtr From(const U& u) {
    return mojo::TypeConverter<GetOpenDeviceResponsePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, GetOpenDeviceResponse>::Convert(*this);
  }


  GetOpenDeviceResponse();

  GetOpenDeviceResponse(
      const std::string& label,
      const ::blink::MediaStreamDevice& device,
      bool pan_tilt_zoom_allowed);


  ~GetOpenDeviceResponse();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = GetOpenDeviceResponsePtr>
  GetOpenDeviceResponsePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, GetOpenDeviceResponse::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, GetOpenDeviceResponse::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, GetOpenDeviceResponse::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        GetOpenDeviceResponse::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        GetOpenDeviceResponse::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::GetOpenDeviceResponse_UnserializedMessageContext<
            UserType, GetOpenDeviceResponse::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<GetOpenDeviceResponse::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return GetOpenDeviceResponse::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::GetOpenDeviceResponse_UnserializedMessageContext<
            UserType, GetOpenDeviceResponse::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<GetOpenDeviceResponse::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::string label;
  
  ::blink::MediaStreamDevice device;
  
  bool pan_tilt_zoom_allowed;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, GetOpenDeviceResponse::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, GetOpenDeviceResponse::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, GetOpenDeviceResponse::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, GetOpenDeviceResponse::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class BLINK_COMMON_EXPORT StreamDevices {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<StreamDevices, T>::value>;
  using DataView = StreamDevicesDataView;
  using Data_ = internal::StreamDevices_Data;

  template <typename... Args>
  static StreamDevicesPtr New(Args&&... args) {
    return StreamDevicesPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static StreamDevicesPtr From(const U& u) {
    return mojo::TypeConverter<StreamDevicesPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, StreamDevices>::Convert(*this);
  }


  StreamDevices();

  StreamDevices(
      const absl::optional<::blink::MediaStreamDevice>& audio_device,
      const absl::optional<::blink::MediaStreamDevice>& video_device);


  ~StreamDevices();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = StreamDevicesPtr>
  StreamDevicesPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, StreamDevices::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, StreamDevices::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, StreamDevices::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        StreamDevices::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        StreamDevices::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::StreamDevices_UnserializedMessageContext<
            UserType, StreamDevices::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<StreamDevices::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return StreamDevices::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::StreamDevices_UnserializedMessageContext<
            UserType, StreamDevices::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<StreamDevices::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  absl::optional<::blink::MediaStreamDevice> audio_device;
  
  absl::optional<::blink::MediaStreamDevice> video_device;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, StreamDevices::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, StreamDevices::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, StreamDevices::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, StreamDevices::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class BLINK_COMMON_EXPORT StreamDevicesSet {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<StreamDevicesSet, T>::value>;
  using DataView = StreamDevicesSetDataView;
  using Data_ = internal::StreamDevicesSet_Data;

  template <typename... Args>
  static StreamDevicesSetPtr New(Args&&... args) {
    return StreamDevicesSetPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static StreamDevicesSetPtr From(const U& u) {
    return mojo::TypeConverter<StreamDevicesSetPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, StreamDevicesSet>::Convert(*this);
  }


  StreamDevicesSet();

  explicit StreamDevicesSet(
      std::vector<StreamDevicesPtr> stream_devices);

StreamDevicesSet(const StreamDevicesSet&) = delete;
StreamDevicesSet& operator=(const StreamDevicesSet&) = delete;

  ~StreamDevicesSet();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = StreamDevicesSetPtr>
  StreamDevicesSetPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, StreamDevicesSet::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, StreamDevicesSet::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, StreamDevicesSet::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        StreamDevicesSet::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        StreamDevicesSet::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::StreamDevicesSet_UnserializedMessageContext<
            UserType, StreamDevicesSet::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<StreamDevicesSet::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return StreamDevicesSet::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::StreamDevicesSet_UnserializedMessageContext<
            UserType, StreamDevicesSet::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<StreamDevicesSet::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::vector<StreamDevicesPtr> stream_devices;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, StreamDevicesSet::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, StreamDevicesSet::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, StreamDevicesSet::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, StreamDevicesSet::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
StreamSelectionInfoPtr StreamSelectionInfo::Clone() const {
  return New(
      mojo::Clone(strategy),
      mojo::Clone(session_id)
  );
}

template <typename T, StreamSelectionInfo::EnableIfSame<T>*>
bool StreamSelectionInfo::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->strategy, other_struct.strategy))
    return false;
  if (!mojo::Equals(this->session_id, other_struct.session_id))
    return false;
  return true;
}

template <typename T, StreamSelectionInfo::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.strategy < rhs.strategy)
    return true;
  if (rhs.strategy < lhs.strategy)
    return false;
  if (lhs.session_id < rhs.session_id)
    return true;
  if (rhs.session_id < lhs.session_id)
    return false;
  return false;
}
template <typename StructPtrType>
MediaStreamDevicePtr MediaStreamDevice::Clone() const {
  return New(
      mojo::Clone(type),
      mojo::Clone(id),
      mojo::Clone(display_id),
      mojo::Clone(video_facing),
      mojo::Clone(group_id),
      mojo::Clone(matched_output_device_id),
      mojo::Clone(name),
      mojo::Clone(input),
      mojo::Clone(session_id),
      mojo::Clone(display_media_info)
  );
}

template <typename T, MediaStreamDevice::EnableIfSame<T>*>
bool MediaStreamDevice::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->type, other_struct.type))
    return false;
  if (!mojo::Equals(this->id, other_struct.id))
    return false;
  if (!mojo::Equals(this->display_id, other_struct.display_id))
    return false;
  if (!mojo::Equals(this->video_facing, other_struct.video_facing))
    return false;
  if (!mojo::Equals(this->group_id, other_struct.group_id))
    return false;
  if (!mojo::Equals(this->matched_output_device_id, other_struct.matched_output_device_id))
    return false;
  if (!mojo::Equals(this->name, other_struct.name))
    return false;
  if (!mojo::Equals(this->input, other_struct.input))
    return false;
  if (!mojo::Equals(this->session_id, other_struct.session_id))
    return false;
  if (!mojo::Equals(this->display_media_info, other_struct.display_media_info))
    return false;
  return true;
}

template <typename T, MediaStreamDevice::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.type < rhs.type)
    return true;
  if (rhs.type < lhs.type)
    return false;
  if (lhs.id < rhs.id)
    return true;
  if (rhs.id < lhs.id)
    return false;
  if (lhs.display_id < rhs.display_id)
    return true;
  if (rhs.display_id < lhs.display_id)
    return false;
  if (lhs.video_facing < rhs.video_facing)
    return true;
  if (rhs.video_facing < lhs.video_facing)
    return false;
  if (lhs.group_id < rhs.group_id)
    return true;
  if (rhs.group_id < lhs.group_id)
    return false;
  if (lhs.matched_output_device_id < rhs.matched_output_device_id)
    return true;
  if (rhs.matched_output_device_id < lhs.matched_output_device_id)
    return false;
  if (lhs.name < rhs.name)
    return true;
  if (rhs.name < lhs.name)
    return false;
  if (lhs.input < rhs.input)
    return true;
  if (rhs.input < lhs.input)
    return false;
  if (lhs.session_id < rhs.session_id)
    return true;
  if (rhs.session_id < lhs.session_id)
    return false;
  if (lhs.display_media_info < rhs.display_media_info)
    return true;
  if (rhs.display_media_info < lhs.display_media_info)
    return false;
  return false;
}
template <typename StructPtrType>
TrackControlsPtr TrackControls::Clone() const {
  return New(
      mojo::Clone(stream_type),
      mojo::Clone(device_id)
  );
}

template <typename T, TrackControls::EnableIfSame<T>*>
bool TrackControls::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->stream_type, other_struct.stream_type))
    return false;
  if (!mojo::Equals(this->device_id, other_struct.device_id))
    return false;
  return true;
}

template <typename T, TrackControls::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.stream_type < rhs.stream_type)
    return true;
  if (rhs.stream_type < lhs.stream_type)
    return false;
  if (lhs.device_id < rhs.device_id)
    return true;
  if (rhs.device_id < lhs.device_id)
    return false;
  return false;
}
template <typename StructPtrType>
StreamControlsPtr StreamControls::Clone() const {
  return New(
      mojo::Clone(audio),
      mojo::Clone(video),
      mojo::Clone(hotword_enabled),
      mojo::Clone(disable_local_echo),
      mojo::Clone(suppress_local_audio_playback),
      mojo::Clone(exclude_system_audio),
      mojo::Clone(exclude_self_browser_surface),
      mojo::Clone(request_pan_tilt_zoom_permission),
      mojo::Clone(request_all_screens),
      mojo::Clone(preferred_display_surface),
      mojo::Clone(dynamic_surface_switching_requested)
  );
}

template <typename T, StreamControls::EnableIfSame<T>*>
bool StreamControls::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->audio, other_struct.audio))
    return false;
  if (!mojo::Equals(this->video, other_struct.video))
    return false;
  if (!mojo::Equals(this->hotword_enabled, other_struct.hotword_enabled))
    return false;
  if (!mojo::Equals(this->disable_local_echo, other_struct.disable_local_echo))
    return false;
  if (!mojo::Equals(this->suppress_local_audio_playback, other_struct.suppress_local_audio_playback))
    return false;
  if (!mojo::Equals(this->exclude_system_audio, other_struct.exclude_system_audio))
    return false;
  if (!mojo::Equals(this->exclude_self_browser_surface, other_struct.exclude_self_browser_surface))
    return false;
  if (!mojo::Equals(this->request_pan_tilt_zoom_permission, other_struct.request_pan_tilt_zoom_permission))
    return false;
  if (!mojo::Equals(this->request_all_screens, other_struct.request_all_screens))
    return false;
  if (!mojo::Equals(this->preferred_display_surface, other_struct.preferred_display_surface))
    return false;
  if (!mojo::Equals(this->dynamic_surface_switching_requested, other_struct.dynamic_surface_switching_requested))
    return false;
  return true;
}

template <typename T, StreamControls::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.audio < rhs.audio)
    return true;
  if (rhs.audio < lhs.audio)
    return false;
  if (lhs.video < rhs.video)
    return true;
  if (rhs.video < lhs.video)
    return false;
  if (lhs.hotword_enabled < rhs.hotword_enabled)
    return true;
  if (rhs.hotword_enabled < lhs.hotword_enabled)
    return false;
  if (lhs.disable_local_echo < rhs.disable_local_echo)
    return true;
  if (rhs.disable_local_echo < lhs.disable_local_echo)
    return false;
  if (lhs.suppress_local_audio_playback < rhs.suppress_local_audio_playback)
    return true;
  if (rhs.suppress_local_audio_playback < lhs.suppress_local_audio_playback)
    return false;
  if (lhs.exclude_system_audio < rhs.exclude_system_audio)
    return true;
  if (rhs.exclude_system_audio < lhs.exclude_system_audio)
    return false;
  if (lhs.exclude_self_browser_surface < rhs.exclude_self_browser_surface)
    return true;
  if (rhs.exclude_self_browser_surface < lhs.exclude_self_browser_surface)
    return false;
  if (lhs.request_pan_tilt_zoom_permission < rhs.request_pan_tilt_zoom_permission)
    return true;
  if (rhs.request_pan_tilt_zoom_permission < lhs.request_pan_tilt_zoom_permission)
    return false;
  if (lhs.request_all_screens < rhs.request_all_screens)
    return true;
  if (rhs.request_all_screens < lhs.request_all_screens)
    return false;
  if (lhs.preferred_display_surface < rhs.preferred_display_surface)
    return true;
  if (rhs.preferred_display_surface < lhs.preferred_display_surface)
    return false;
  if (lhs.dynamic_surface_switching_requested < rhs.dynamic_surface_switching_requested)
    return true;
  if (rhs.dynamic_surface_switching_requested < lhs.dynamic_surface_switching_requested)
    return false;
  return false;
}
template <typename StructPtrType>
GetOpenDeviceResponsePtr GetOpenDeviceResponse::Clone() const {
  return New(
      mojo::Clone(label),
      mojo::Clone(device),
      mojo::Clone(pan_tilt_zoom_allowed)
  );
}

template <typename T, GetOpenDeviceResponse::EnableIfSame<T>*>
bool GetOpenDeviceResponse::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->label, other_struct.label))
    return false;
  if (!mojo::Equals(this->device, other_struct.device))
    return false;
  if (!mojo::Equals(this->pan_tilt_zoom_allowed, other_struct.pan_tilt_zoom_allowed))
    return false;
  return true;
}

template <typename T, GetOpenDeviceResponse::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.label < rhs.label)
    return true;
  if (rhs.label < lhs.label)
    return false;
  if (lhs.device < rhs.device)
    return true;
  if (rhs.device < lhs.device)
    return false;
  if (lhs.pan_tilt_zoom_allowed < rhs.pan_tilt_zoom_allowed)
    return true;
  if (rhs.pan_tilt_zoom_allowed < lhs.pan_tilt_zoom_allowed)
    return false;
  return false;
}
template <typename StructPtrType>
StreamDevicesPtr StreamDevices::Clone() const {
  return New(
      mojo::Clone(audio_device),
      mojo::Clone(video_device)
  );
}

template <typename T, StreamDevices::EnableIfSame<T>*>
bool StreamDevices::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->audio_device, other_struct.audio_device))
    return false;
  if (!mojo::Equals(this->video_device, other_struct.video_device))
    return false;
  return true;
}

template <typename T, StreamDevices::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.audio_device < rhs.audio_device)
    return true;
  if (rhs.audio_device < lhs.audio_device)
    return false;
  if (lhs.video_device < rhs.video_device)
    return true;
  if (rhs.video_device < lhs.video_device)
    return false;
  return false;
}
template <typename StructPtrType>
StreamDevicesSetPtr StreamDevicesSet::Clone() const {
  return New(
      mojo::Clone(stream_devices)
  );
}

template <typename T, StreamDevicesSet::EnableIfSame<T>*>
bool StreamDevicesSet::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->stream_devices, other_struct.stream_devices))
    return false;
  return true;
}

template <typename T, StreamDevicesSet::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.stream_devices < rhs.stream_devices)
    return true;
  if (rhs.stream_devices < lhs.stream_devices)
    return false;
  return false;
}


}  // blink::mojom

namespace mojo {


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::StreamSelectionInfo::DataView,
                                         ::blink::mojom::StreamSelectionInfoPtr> {
  static bool IsNull(const ::blink::mojom::StreamSelectionInfoPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::StreamSelectionInfoPtr* output) { output->reset(); }

  static decltype(::blink::mojom::StreamSelectionInfo::strategy) strategy(
      const ::blink::mojom::StreamSelectionInfoPtr& input) {
    return input->strategy;
  }

  static const decltype(::blink::mojom::StreamSelectionInfo::session_id)& session_id(
      const ::blink::mojom::StreamSelectionInfoPtr& input) {
    return input->session_id;
  }

  static bool Read(::blink::mojom::StreamSelectionInfo::DataView input, ::blink::mojom::StreamSelectionInfoPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::MediaStreamDevice::DataView,
                                         ::blink::mojom::MediaStreamDevicePtr> {
  static bool IsNull(const ::blink::mojom::MediaStreamDevicePtr& input) { return !input; }
  static void SetToNull(::blink::mojom::MediaStreamDevicePtr* output) { output->reset(); }

  static decltype(::blink::mojom::MediaStreamDevice::type) type(
      const ::blink::mojom::MediaStreamDevicePtr& input) {
    return input->type;
  }

  static const decltype(::blink::mojom::MediaStreamDevice::id)& id(
      const ::blink::mojom::MediaStreamDevicePtr& input) {
    return input->id;
  }

  static decltype(::blink::mojom::MediaStreamDevice::display_id) display_id(
      const ::blink::mojom::MediaStreamDevicePtr& input) {
    return input->display_id;
  }

  static decltype(::blink::mojom::MediaStreamDevice::video_facing) video_facing(
      const ::blink::mojom::MediaStreamDevicePtr& input) {
    return input->video_facing;
  }

  static const decltype(::blink::mojom::MediaStreamDevice::group_id)& group_id(
      const ::blink::mojom::MediaStreamDevicePtr& input) {
    return input->group_id;
  }

  static const decltype(::blink::mojom::MediaStreamDevice::matched_output_device_id)& matched_output_device_id(
      const ::blink::mojom::MediaStreamDevicePtr& input) {
    return input->matched_output_device_id;
  }

  static const decltype(::blink::mojom::MediaStreamDevice::name)& name(
      const ::blink::mojom::MediaStreamDevicePtr& input) {
    return input->name;
  }

  static const decltype(::blink::mojom::MediaStreamDevice::input)& input(
      const ::blink::mojom::MediaStreamDevicePtr& input) {
    return input->input;
  }

  static const decltype(::blink::mojom::MediaStreamDevice::session_id)& session_id(
      const ::blink::mojom::MediaStreamDevicePtr& input) {
    return input->session_id;
  }

  static const decltype(::blink::mojom::MediaStreamDevice::display_media_info)& display_media_info(
      const ::blink::mojom::MediaStreamDevicePtr& input) {
    return input->display_media_info;
  }

  static bool Read(::blink::mojom::MediaStreamDevice::DataView input, ::blink::mojom::MediaStreamDevicePtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::TrackControls::DataView,
                                         ::blink::mojom::TrackControlsPtr> {
  static bool IsNull(const ::blink::mojom::TrackControlsPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::TrackControlsPtr* output) { output->reset(); }

  static decltype(::blink::mojom::TrackControls::stream_type) stream_type(
      const ::blink::mojom::TrackControlsPtr& input) {
    return input->stream_type;
  }

  static const decltype(::blink::mojom::TrackControls::device_id)& device_id(
      const ::blink::mojom::TrackControlsPtr& input) {
    return input->device_id;
  }

  static bool Read(::blink::mojom::TrackControls::DataView input, ::blink::mojom::TrackControlsPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::StreamControls::DataView,
                                         ::blink::mojom::StreamControlsPtr> {
  static bool IsNull(const ::blink::mojom::StreamControlsPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::StreamControlsPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::StreamControls::audio)& audio(
      const ::blink::mojom::StreamControlsPtr& input) {
    return input->audio;
  }

  static const decltype(::blink::mojom::StreamControls::video)& video(
      const ::blink::mojom::StreamControlsPtr& input) {
    return input->video;
  }

  static decltype(::blink::mojom::StreamControls::hotword_enabled) hotword_enabled(
      const ::blink::mojom::StreamControlsPtr& input) {
    return input->hotword_enabled;
  }

  static decltype(::blink::mojom::StreamControls::disable_local_echo) disable_local_echo(
      const ::blink::mojom::StreamControlsPtr& input) {
    return input->disable_local_echo;
  }

  static decltype(::blink::mojom::StreamControls::suppress_local_audio_playback) suppress_local_audio_playback(
      const ::blink::mojom::StreamControlsPtr& input) {
    return input->suppress_local_audio_playback;
  }

  static decltype(::blink::mojom::StreamControls::exclude_system_audio) exclude_system_audio(
      const ::blink::mojom::StreamControlsPtr& input) {
    return input->exclude_system_audio;
  }

  static decltype(::blink::mojom::StreamControls::exclude_self_browser_surface) exclude_self_browser_surface(
      const ::blink::mojom::StreamControlsPtr& input) {
    return input->exclude_self_browser_surface;
  }

  static decltype(::blink::mojom::StreamControls::request_pan_tilt_zoom_permission) request_pan_tilt_zoom_permission(
      const ::blink::mojom::StreamControlsPtr& input) {
    return input->request_pan_tilt_zoom_permission;
  }

  static decltype(::blink::mojom::StreamControls::request_all_screens) request_all_screens(
      const ::blink::mojom::StreamControlsPtr& input) {
    return input->request_all_screens;
  }

  static decltype(::blink::mojom::StreamControls::preferred_display_surface) preferred_display_surface(
      const ::blink::mojom::StreamControlsPtr& input) {
    return input->preferred_display_surface;
  }

  static decltype(::blink::mojom::StreamControls::dynamic_surface_switching_requested) dynamic_surface_switching_requested(
      const ::blink::mojom::StreamControlsPtr& input) {
    return input->dynamic_surface_switching_requested;
  }

  static bool Read(::blink::mojom::StreamControls::DataView input, ::blink::mojom::StreamControlsPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::GetOpenDeviceResponse::DataView,
                                         ::blink::mojom::GetOpenDeviceResponsePtr> {
  static bool IsNull(const ::blink::mojom::GetOpenDeviceResponsePtr& input) { return !input; }
  static void SetToNull(::blink::mojom::GetOpenDeviceResponsePtr* output) { output->reset(); }

  static const decltype(::blink::mojom::GetOpenDeviceResponse::label)& label(
      const ::blink::mojom::GetOpenDeviceResponsePtr& input) {
    return input->label;
  }

  static const decltype(::blink::mojom::GetOpenDeviceResponse::device)& device(
      const ::blink::mojom::GetOpenDeviceResponsePtr& input) {
    return input->device;
  }

  static decltype(::blink::mojom::GetOpenDeviceResponse::pan_tilt_zoom_allowed) pan_tilt_zoom_allowed(
      const ::blink::mojom::GetOpenDeviceResponsePtr& input) {
    return input->pan_tilt_zoom_allowed;
  }

  static bool Read(::blink::mojom::GetOpenDeviceResponse::DataView input, ::blink::mojom::GetOpenDeviceResponsePtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::StreamDevices::DataView,
                                         ::blink::mojom::StreamDevicesPtr> {
  static bool IsNull(const ::blink::mojom::StreamDevicesPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::StreamDevicesPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::StreamDevices::audio_device)& audio_device(
      const ::blink::mojom::StreamDevicesPtr& input) {
    return input->audio_device;
  }

  static const decltype(::blink::mojom::StreamDevices::video_device)& video_device(
      const ::blink::mojom::StreamDevicesPtr& input) {
    return input->video_device;
  }

  static bool Read(::blink::mojom::StreamDevices::DataView input, ::blink::mojom::StreamDevicesPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::StreamDevicesSet::DataView,
                                         ::blink::mojom::StreamDevicesSetPtr> {
  static bool IsNull(const ::blink::mojom::StreamDevicesSetPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::StreamDevicesSetPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::StreamDevicesSet::stream_devices)& stream_devices(
      const ::blink::mojom::StreamDevicesSetPtr& input) {
    return input->stream_devices;
  }

  static bool Read(::blink::mojom::StreamDevicesSet::DataView input, ::blink::mojom::StreamDevicesSetPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_MEDIASTREAM_MEDIA_STREAM_MOJOM_H_